Index: GTP/trunk/Lib/Vis/Preprocessing/src/UnigraphicsParser.h
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/UnigraphicsParser.h	(revision 863)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/UnigraphicsParser.h	(revision 1001)
@@ -15,5 +15,7 @@
   UnigraphicsParser(): Parser() {}
   
-  virtual bool ParseFile(const std::string filename, SceneGraphNode **root, const bool loadPolygonsAsMeshes = false);
+  virtual bool ParseFile(const std::string filename, 
+						 SceneGraphNode **root, 
+						 const bool loadPolygonsAsMeshes = false);
   
 };
Index: GTP/trunk/Lib/Vis/Preprocessing/src/Material.h
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/Material.h	(revision 860)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/Material.h	(revision 1001)
@@ -33,11 +33,15 @@
   RgbColor mAmbientColor;
   
-  Material() 
+  Material(): mId(0)
   {
   }
   
+  Material(const int id): mId(id)
+  {
+  }
+
   Material(const RgbColor &color):mDiffuseColor(color),
 								  mAmbientColor(color),
-								  mSpecularColor(0,0,0)
+								  mSpecularColor(0,0,0), mId(0)
   {
   }
@@ -45,4 +49,15 @@
   friend Material RandomMaterial();
   
+  /** Returns unique material id.
+  */
+  int GetId() const
+  {
+	  return mId;
+  }
+
+protected:
+
+	// unique material id
+	int mId;
 };
 
Index: GTP/trunk/Lib/Vis/Preprocessing/src/VrmlExporter.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/VrmlExporter.cpp	(revision 863)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/VrmlExporter.cpp	(revision 1001)
@@ -24,4 +24,5 @@
 }
 
+
 VrmlExporter::~VrmlExporter()
 {
@@ -31,6 +32,6 @@
 
 bool VrmlExporter::ExportRays(const RayContainer &rays,
-						const float length,
-						const RgbColor &color)
+							  const float length,
+							  const RgbColor &color)
 {
   RayContainer::const_iterator ri = rays.begin();
@@ -115,6 +116,6 @@
   for (; ri != rays.end(); ri++) {
     const Vector3 a = (*ri)->GetOrigin();
-	//const Vector3 b = (*ri)->mTerminationObject ? (*ri)->GetTermination() : a + 1000 * Normalize((*ri)->GetDir());
-	const Vector3 b = (*ri)->GetTermination(); // matt: change again!!
+	const Vector3 b = (*ri)->mTerminationObject ? (*ri)->GetTermination() : a + 1000 * Normalize((*ri)->GetDir());
+	//const Vector3 b = (*ri)->GetTermination(); // matt: change back!!
 
     stream<<a.x<<" "<<a.y<<" "<<a.z<<" ,";
@@ -152,12 +153,14 @@
 }
 
+
 void VrmlExporter::ExportIntersectable(Intersectable *object)
 {
 	switch (object->Type()) 
 	{
-	
 	case Intersectable::MESH_INSTANCE:
+		ExportMeshInstance((MeshInstance *)object);
+		break;
 	case Intersectable::TRANSFORMED_MESH_INSTANCE:
-		ExportMeshInstance((MeshInstance *)object);
+		ExportTransformedMeshInstance(dynamic_cast<TransformedMeshInstance *>(object));
 		break;
 	case Intersectable::VIEW_CELL:
@@ -180,4 +183,16 @@
 
 
+void VrmlExporter::ExportTransformedMeshInstance(TransformedMeshInstance *mi)
+{
+	Mesh mesh(*mi->GetMesh());
+
+	Matrix4x4 m;
+	mi->GetWorldTransform(m);
+	mesh.ApplyTransformation(m);
+
+	ExportMesh(&mesh);
+}
+
+
 void VrmlExporter::ExportViewCells(const ViewCellContainer &viewCells)
 {
@@ -189,4 +204,5 @@
 	}
 }
+
 
 void VrmlExporter::ExportBspLeaves(const BspTree &tree, const int maxPvs)
@@ -290,6 +306,5 @@
 	stream << "}" << endl; // end material
 	stream << "}" << endl; // end apperance
-	//stream << "}" << endl; // end shape
-
+	
 
 	// wireframe modes => set indexed lines
@@ -314,8 +329,8 @@
 	{
 		Face *face = *fi;
-	  
+	 
 		VertexIndexContainer::const_iterator vi = face->mVertexIndices.begin();
-	  
-		for (; vi != face->mVertexIndices.end(); vi++)
+	 
+		for (; vi != face->mVertexIndices.end(); ++ vi)
 		{
 			stream << *vi << " ";
@@ -331,5 +346,5 @@
 
 	stream << "]" << endl; // end coordIndex
-	
+
 
 	stream << "coord Coordinate {" << endl;
@@ -385,6 +400,5 @@
 	stream << "}" << endl; // end material
 	stream << "}" << endl; // end apperance
-	//stream << "}" << endl; // end shape
-
+	
 
 	// wireframe modes => set indexed lines
Index: GTP/trunk/Lib/Vis/Preprocessing/src/Matrix4x4.h
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/Matrix4x4.h	(revision 860)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/Matrix4x4.h	(revision 1001)
@@ -34,6 +34,8 @@
 
   // Fundamental operations
-  int Invert();		      // Invert the matrix .. returns 0 = regular
-  void Transpose();				// Transpose the matrix
+  /// Invert the matrix .. returns 0 = regular
+  int Invert();		
+  /// Transpose the matrix
+  void Transpose();	
 
   void
Index: GTP/trunk/Lib/Vis/Preprocessing/src/X3dParser.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/X3dParser.cpp	(revision 971)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/X3dParser.cpp	(revision 1001)
@@ -29,4 +29,5 @@
 #include "Triangle3.h"
 #include "ViewCellsManager.h"
+#include "ResourceManager.h"
 
 namespace GtpVisibilityPreprocessor {
@@ -60,11 +61,13 @@
 #define ROTATE_SCENE 0
 
-
-static void RotateMesh(Mesh *mesh)
+static int sUniqueMeshIdx = 0;
+
+// hack: rotate mesh by n degrees
+static void RotateMesh(Mesh *mesh, const float angle)
 {
 	VertexContainer::iterator it, it_end = mesh->mVertices.end();
 
-	const float angle = 30.0f * PI / 180.0f;
-	const Matrix4x4 rot = RotationYMatrix(angle);
+	const float angleRad = angle * PI / 180.0f;
+	const Matrix4x4 rot = RotationYMatrix(angleRad);
 
 	for (it = mesh->mVertices.begin(); it != it_end; ++ it)
@@ -83,8 +86,10 @@
   , mSpaceCount(0)
   , mLoadPolygonsAsMeshes(loadPolygonsAsMeshes)
-{
-  mCurrentNode = root;
-  // this matrix should never be removed from stack
-  //mTransformations.push(IdentityMatrix());
+  , mCurrentMesh(NULL)
+{
+	mCurrentNode = root;
+
+	// this matrix should never be removed from stack
+	//mTransformations.push(IdentityMatrix());
 }
 
@@ -99,29 +104,16 @@
 //  StdInParseHandlers: Implementation of the SAX DocumentHandler interface
 // ---------------------------------------------------------------------------
+
 void X3dParseHandlers::endElement(const XMLCh* const name)
 {
-  StrX lname(name);
-  string element(lname.LocalForm());
-  
-  // only create new mesh instance if define mechanism was not used
-  if (element == "Shape")
-    EndShape();
-
-  if (element == "Transform")
-	  EndTransform();
-}
-
-
-
-
-void X3dParseHandlers::ApplyTransformation(Mesh *mesh, 
-										   const Matrix4x4 &m) const
-{
-	VertexContainer::iterator it, it_end = mesh->mVertices.end();
-
-	for (it = mesh->mVertices.begin(); it != it_end; ++ it)
-	{
-		(*it) = m * (*it);        
-	}
+	StrX lname(name);
+	string element(lname.LocalForm());
+
+	// only create new mesh instance if define mechanism was not used
+	if (element == "Shape")
+		EndShape();
+
+	if (element == "Transform")
+		EndTransform();
 }
 
@@ -134,7 +126,21 @@
 		trafos.pop();
 
-		ApplyTransformation(mesh, m);
-	}
-}
+		mesh->ApplyTransformation(m);
+	}
+}
+
+
+void X3dParseHandlers::ApplyTransformations(TrafoStack trafos, 
+											TransformedMeshInstance *mi) const
+{
+	while (!trafos.empty())
+	{
+		const Matrix4x4 m = trafos.top();
+		trafos.pop();
+
+		mi->ApplyWorldTransform(m);
+	}
+}
+
 
 void X3dParseHandlers::StartTransform(AttributeList&  attributes)
@@ -143,4 +149,5 @@
 
 	const int len = attributes.getLength();
+
     Matrix4x4 *rotm = NULL;
 	Matrix4x4 *scalem = NULL;
@@ -208,86 +215,102 @@
 void X3dParseHandlers::EndShape()
 {
-	// this shape is a definition => don't create mesh instance
-	if (mIsMeshDefinition) 
-{
-		mMeshDefinitions[mCurrentMeshName.c_str()] = mCurrentMesh;
-		//cout << "new definition: " << mCurrentMeshName << endl;
+	 //-- if shape is merely a definition => don't create particular mesh instance
+	 if (!mCurrentMesh || mIsMeshDefinition) 
+	 { 
+		 return;
+	 }
+
+	 //-- each polygon is one single mesh
+	 if (mLoadPolygonsAsMeshes)
+	 {
+		 FaceContainer::const_iterator fit, fit_end = mCurrentMesh->mFaces.end();
+
+		 cout << "m";
 		
-		return;
-	}
-
-	// each polygon is one single mesh
-	if (mLoadPolygonsAsMeshes)
-	{
-		//if (mCurrentMesh->mFaces.empty())	cout << "error!" << endl;
-
-		FaceContainer::const_iterator fit, fit_end = mCurrentMesh->mFaces.end();
-
-		cout << "m";
-		//cout << "m: " << mCurrentMesh->mFaces.size() << endl;
-		for (fit = mCurrentMesh->mFaces.begin(); fit != fit_end; ++ fit)
-		{
-			cout << "f";
-
-			Face *face = *fit;
-			// only one face per mesh
-			Mesh *mesh = new Mesh();
-			VertexIndexContainer vc;
-					
-			VertexIndexContainer::const_iterator vit, vit_end = face->mVertexIndices.end();
+		 for (fit = mCurrentMesh->mFaces.begin(); fit != fit_end; ++ fit)
+		 {
+			 cout << "f";
+
+			 Face *face = *fit;
+		
+			 // we create a new mesh for each face from the current mesh
+			 Mesh *mesh = MeshManager::GetSingleton()->CreateResource();
 			
-			int i = 0;
-			for (vit = face->mVertexIndices.begin(); vit != vit_end; ++ vit, ++ i)
+			 VertexIndexContainer::const_iterator vit, vit_end = face->mVertexIndices.end();
+		
+			 int i = 0;
+			 VertexIndexContainer vcIndices;
+
+			 for (vit = face->mVertexIndices.begin(); vit != vit_end; ++ vit, ++ i)
+			 {
+				 cout << "i";
+				 const int index = (*vit);
+
+				 // add vertices
+				 mesh->mVertices.push_back(mCurrentMesh->mVertices[index]);
+
+				 // indices don't make much sense if mesh = face, but
+				 // we need them anyway ...
+				 vcIndices.push_back(i);
+			 }
+
+			 mesh->mFaces.push_back(new Face(vcIndices));
+
+			 // NOTE: should rather be written into trafo of mesh instance
+			 ApplyTransformations(mTransformations, mesh);
+
+			 mesh->Preprocess();
+				
+			 // make an instance of this mesh
+			 MeshInstance *mi = new MeshInstance(mesh);
+			 mCurrentNode->mGeometry.push_back(mi);
+		 }
+
+		 // this mesh is not needed, unless it is used as a definition
+		 if (!mUsingMeshDefinition) 
+		 	 MeshManager::GetSingleton()->DestroyEntry(mCurrentMesh->GetId());
+	}
+	else // default usage: create a mesh instance from the current mesh
+	{ 
+		MeshInstance *mi;
+
+		if (0 && !mUsingMeshDefinition) 
+		{
+			// make an instance of this mesh
+            mi = new MeshInstance(mCurrentMesh);
+
+			// this mesh is used only once => write transformations directly into it
+			ApplyTransformations(mTransformations, mCurrentMesh);
+		}
+		else
+		{
+			 // make an instance of this mesh
+			 TransformedMeshInstance *tmi = new TransformedMeshInstance(mCurrentMesh);
+
+			 // apply transformation on the instance of the mesh 
+			 ApplyTransformations(mTransformations, tmi);
+
+			 mi = tmi;
+		}
+		
+		if (mCurrentMaterial)
+		{
+			// HACK: add the material to the mesh directly if no material yet
+			if (mCurrentMesh->mMaterial)
 			{
-				cout << "i";
-				int index = (*vit);
-				// add vertices
-				mesh->mVertices.push_back(mCurrentMesh->mVertices[index]);
-				vc.push_back(i);
+				mCurrentMesh->mMaterial = mCurrentMaterial;
 			}
-
-			mesh->mFaces.push_back(new Face(vc));
-
-			// NOTE: should rather be written into trafo of mesh instance
-			ApplyTransformations(mTransformations, mesh);
-
-			mesh->Preprocess();
-				
-			// make an instance of this mesh
-			MeshInstance *mi = new MeshInstance(mesh);
-			mCurrentNode->mGeometry.push_back(mi);
-		}
-
-		// LEAK!! TODO: delete if not defd
-		if (!mUsingMeshDefinition)
-			delete mCurrentMesh;
-
-		//mCurrentVertices.clear();
-		//mCurrentVertexIndices.clear();
-	}
-	else
-	{ 
-		if (!mCurrentMesh->mFaces.empty()) 
-		{
-			// should rather be written into the transformation
-			// of a mesh instance
-			ApplyTransformations(mTransformations, mCurrentMesh);
-
-			mCurrentMesh->Preprocess();
-			// make an instance of this mesh
-			MeshInstance *mi = new MeshInstance(mCurrentMesh);
-
-			mCurrentNode->mGeometry.push_back(mi);
-			// set the object id to a unique value
-			//mi->SetId(mCurrentObjectId ++);
-		} 
-		else 
-		{
-			// empty mesh => discard
-			cout<<"X";
-
-			delete mCurrentMesh;
-		}
-
+			else // add material to the instance
+			{
+				mi->SetMaterial(mCurrentMaterial);
+			}
+		}
+
+		// create local mesh kd tree
+		mCurrentMesh->Preprocess();
+		// add to scene graph
+		mCurrentNode->mGeometry.push_back(mi);
+	
+		// reset current mesh
 		mCurrentMesh = NULL;
 	}
@@ -297,46 +320,64 @@
 void X3dParseHandlers::StartIndexedFaceSet(AttributeList&  attributes)
 {
-  int len = attributes.getLength();
-
-  int i;
-  VertexIndexContainer vertices;
+	//-- indexedfaceset corresponds  to Mesh in our implementation
+	const int len = attributes.getLength();
+
+	VertexIndexContainer vertices;
   
 	mIsMeshDefinition = false;
 	mUsingMeshDefinition = false;
-	for (i = 0; i < len; ++ i) 
+
+	for (int i = 0; i < len; ++ i) 
 	{
-		string attrName(StrX(attributes.getName(i)).LocalForm());
-	  
-		// this is a definition of a mesh
-		if (attrName == "DEF")
-		{
+		const string attrName(StrX(attributes.getName(i)).LocalForm());
+	
+		//-- we use an already defined mesh
+		if (attrName == "USE")
+		{
+			StrX attrValue(attributes.getValue(i));
+			const char *meshName = attrValue.LocalForm();
+
+			mUsingMeshDefinition = true;
+
+            // retrieve mesh from mesh container
+			const int meshIdx = mMeshDefinitions[meshName];
+
+			mCurrentMesh = 
+				MeshManager::GetSingleton()->FindEntry(meshIdx);
+
+			//Debug << "retrieving mesh definition: " << mCurrentMeshName << endl;
+			cout << "u";
+		}
+		else if (attrName == "DEF") //-- a definition of a mesh
+		{
+			const StrX attrValue(attributes.getValue(i));
+			const char *meshName = attrValue.LocalForm();
+
+			// this is only a definition, don't create actual  instance
 			mIsMeshDefinition = true;
+			
+			//-- create new mesh definition
+			mCurrentMesh = MeshManager::GetSingleton()->CreateResource();
+			
+			// store the mesh defination in a lookup table
+			mMeshDefinitions[meshName] = mCurrentMesh->GetId();
+			cout << "d";
+		}
+		
+		//-- read coordinate indices for current mesh
+		else if (attrName == "coordIndex") 
+		{
 			StrX attrValue(attributes.getValue(i));
 			const char *ptr = attrValue.LocalForm();
-			mCurrentMeshName = ptr;
-
-			cout << "d";
-		}
-		
-		// we use an already defined mesh
-		if (attrName == "USE")
-		{
-			StrX attrValue(attributes.getValue(i));
-
-			// discard new mesh and assign defined mesh
-			DEL_PTR(mCurrentMesh);
-			const char *ptr = attrValue.LocalForm();
-
-			mCurrentMesh = mMeshDefinitions[ptr];
-			mUsingMeshDefinition = true;
-			cout << "u";
-		}
-		
-		if (attrName == "coordIndex") 
-		{
-			StrX attrValue(attributes.getValue(i));
+
+			//-- immediate use: create a new mesh using a generic name
+			if (!mCurrentMesh)
+			{
+				mCurrentMesh = MeshManager::GetSingleton()->CreateResource();
+			}
+
 			// handle coordIndex
 			vertices.clear();
-			const char *ptr = attrValue.LocalForm();
+			
 		  
 			char *endptr;
@@ -372,28 +413,60 @@
 
 void
-X3dParseHandlers::StartMaterial(
-				AttributeList&  attributes)
-{
-  int len = attributes.getLength();
-  int i;
-  if (!mCurrentMesh->mMaterial)
-    mCurrentMesh->mMaterial = new Material;
-  for (i=0; i < len; i++) {
-    string attrName(StrX(attributes.getName(i)).LocalForm());
-    StrX attrValue(attributes.getValue(i));
-    const char *ptr = attrValue.LocalForm();
-    if (attrName == "diffuseColor") {
-      float r, g, b;
-      if (sscanf(ptr, "%f %f %f", &r, &g, &b) == 3)
-	mCurrentMesh->mMaterial->mDiffuseColor = RgbColor(r, g, b);
-    }
-  }
-}
-
-void
-X3dParseHandlers::StartCoordinate(
-				  AttributeList&  attributes)
-{
-	int len = attributes.getLength();
+X3dParseHandlers::StartMaterial(AttributeList&  attributes)
+{
+	const int len = attributes.getLength();
+		
+	mCurrentMaterial = MaterialManager::GetSingleton()->CreateResource();
+  
+	for (int i = 0; i < len; ++ i) 
+	{
+		const string attrName(StrX(attributes.getName(i)).LocalForm());
+		
+		const StrX attrValue(attributes.getValue(i));
+		const char *ptr = attrValue.LocalForm();
+
+
+		//-- we use an already defined material
+		if (attrName == "USE")
+		{
+			//mUsingMaterialDefinition = true;
+			string matName(ptr);
+
+            // retrieve mesh from mesh container
+			const int matIdx = mMaterialDefinitions[matName];
+
+			mCurrentMaterial = 
+				MaterialManager::GetSingleton()->FindEntry(matIdx);
+
+			//Debug << "retrieving mesh definition: " << mCurrentMeshName << endl;
+			cout << "u";
+		}
+		else if (attrName == "DEF") //-- a definition of a material
+		{
+			//mIsMaterialDefinition = true;
+			string matName(ptr);
+		
+			//-- create new material definition
+			mCurrentMaterial = MaterialManager::GetSingleton()->CreateResource();
+			// store the mesh defination in a lookup table
+			mMaterialDefinitions[matName] = mCurrentMaterial->GetId();
+			cout << "d";
+		}
+		// TODO: support not only diffuse material
+		else if (attrName == "diffuseColor") 
+		{
+			float r, g, b;
+      
+			if (sscanf(ptr, "%f %f %f", &r, &g, &b) == 3)
+				mCurrentMaterial->mDiffuseColor = RgbColor(r, g, b);
+		}
+	}
+}
+
+
+void
+X3dParseHandlers::StartCoordinate(AttributeList&  attributes)
+{
+	const int len = attributes.getLength();
 	
 	int i;
@@ -402,5 +475,5 @@
 	for (i=0; i < len; i++) 
 	{
-		string attrName(StrX(attributes.getName(i)).LocalForm());
+		const string attrName(StrX(attributes.getName(i)).LocalForm());
 	  
 		if (attrName == "point") 
@@ -441,5 +514,6 @@
 				vertices.push_back(v);
 			}
-			
+	
+			// substitute vertices into current mesh
 			mCurrentMesh->mVertices = vertices;
 		}
@@ -456,21 +530,25 @@
   
   if (element == "IndexedFaceSet") {
-    // create a new mesh node in the scene graph
-    StartIndexedFaceSet(attributes);
+	  // create a new mesh node in the scene graph
+	  StartIndexedFaceSet(attributes);
   }
  
   if (element == "Shape") {
-    cout << "+";
-	mCurrentMesh = new Mesh;
+	  cout << "+"; 
+
+	  // reset current shape values
+	  mCurrentMesh = NULL;
+	  mCurrentMaterial = NULL;
+	  mCurrentVertexIndices.clear();
+	  //mCurrentVertices.clear();
   }
   
-  if (element == "Coordinate") 
-  {
-    if (mCurrentMesh)
-      StartCoordinate(attributes);
+  if (element == "Coordinate") {
+	  StartCoordinate(attributes);
   }
-  
-  if (element == "Material") {
-    StartMaterial(attributes);
+
+  // todo
+  if (0 && element == "Material") {
+	  StartMaterial(attributes);
   }
   
@@ -479,5 +557,5 @@
   }
 
-  mElementCount++;
+  ++ mElementCount;
   mAttrCount += attributes.getLength();
 }
@@ -485,5 +563,5 @@
 void
 X3dParseHandlers::characters(const XMLCh* const chars,
-			     const unsigned int length)
+							 const unsigned int length)
 {
   mCharacterCount += length;
@@ -492,5 +570,5 @@
 void
 X3dParseHandlers::ignorableWhitespace(const XMLCh* const chars,
-				      const unsigned int length)
+									  const unsigned int length)
 {
   mSpaceCount += length;
@@ -507,8 +585,9 @@
 
 
-
 // ---------------------------------------------------------------------------
 //  StdInParseHandlers: Overrides of the SAX ErrorHandler interface
 // ---------------------------------------------------------------------------
+
+
 void
 X3dParseHandlers::error(const SAXParseException& e)
@@ -600,4 +679,5 @@
 	const unsigned long startMillis = XMLPlatformUtils::getCurrentMillis();
 	parser->parse(filename.c_str());
+	
 	const unsigned long endMillis = XMLPlatformUtils::getCurrentMillis();
 	duration = endMillis - startMillis;
@@ -674,9 +754,10 @@
 void X3dViewCellsParseHandlers::endElement(const XMLCh* const name)
 {
-  StrX lname(name);
-  string element(lname.LocalForm());
- 
-  if (element == "Shape")
-    EndShape();
+	StrX lname(name);
+
+	string element(lname.LocalForm());
+
+	if (element == "Shape")
+		EndShape();
 }
 
@@ -694,8 +775,4 @@
 	int i;
 	
-	// clear previous vertex indices
-	mCurrentVertexIndices.clear();
-
-
 	for (i=0; i < len; i++) 
 	{
Index: GTP/trunk/Lib/Vis/Preprocessing/src/LogManager.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/LogManager.cpp	(revision 1001)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/LogManager.cpp	(revision 1001)
@@ -0,0 +1,31 @@
+#include "LogManager.h"
+using namespace std;
+
+namespace GtpVisibilityPreprocessor {
+
+LogManager *LogManager::sLogManager = NULL;
+
+
+LogManager *LogManager::GetSingleton()
+{
+	if (!sLogManager)
+	{
+		sLogManager = new LogManager();
+	}
+
+	return sLogManager;
+}
+
+
+LogManager::LogManager()
+{
+	mOutStream.open("preprocessor.log");
+}
+
+
+void LogManager::LogMessage(const string &str)
+{
+	mOutStream << str.c_str();
+}
+
+}
Index: GTP/trunk/Lib/Vis/Preprocessing/src/OcclusionQuery.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/OcclusionQuery.cpp	(revision 1001)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/OcclusionQuery.cpp	(revision 1001)
@@ -0,0 +1,146 @@
+//#include "glInterface.h"
+#include "OcclusionQuery.h"
+#include <iostream>
+//#include <GL/gl.h>
+//#include <QtOpenGL>
+#include <glInterface.h>
+
+
+using namespace std;
+
+namespace GtpVisibilityPreprocessor {
+
+bool OcclusionQuery::sUseArbQueries = true;
+
+
+OcclusionQuery::OcclusionQuery()
+{
+	GLuint id;
+
+	if (sUseArbQueries)
+	{
+		glGenQueriesARB(1, &id);
+	}
+	else
+	{		
+		glGenOcclusionQueriesNV(1, &id);
+	}
+}
+
+OcclusionQuery::OcclusionQuery(const unsigned int idx):
+mId(idx)
+{}
+
+
+OcclusionQuery::~OcclusionQuery()
+{
+	if (sUseArbQueries)
+	{
+		glDeleteQueriesARB(1, &mId);
+	}
+	else
+	{
+		glDeleteOcclusionQueriesNV(1, &mId);
+	}
+	
+}
+//-----------------------------------------------------------------------
+void OcclusionQuery::BeginQuery()
+{
+	if (sUseArbQueries)
+	{
+		glBeginQueryARB(GL_SAMPLES_PASSED_ARB, mId);
+	}
+	else
+	{
+		glBeginOcclusionQueryNV(mId);
+	}
+}
+//-----------------------------------------------------------------------
+void OcclusionQuery::EndQuery()
+{
+	if (sUseArbQueries)
+	{
+		glEndQueryARB(GL_SAMPLES_PASSED_ARB);
+	}
+	else
+	{
+		glEndOcclusionQueryNV();	
+	}
+}
+
+
+unsigned int OcclusionQuery::GetQueryId() const
+{
+	return mId;
+}
+
+bool OcclusionQuery::ResultAvailable() const
+{
+	GLuint available;
+
+	if (sUseArbQueries)
+	{
+		//GLint available;
+		glGetQueryObjectuivARB(mId,
+							   GL_QUERY_RESULT_AVAILABLE_ARB,
+                               &available);
+		return available == GL_TRUE;
+	}
+	else
+	{
+		
+		glGetOcclusionQueryuivNV(mId, GL_PIXEL_COUNT_AVAILABLE_NV, &available);
+
+		return available == GL_TRUE;
+	}
+
+}
+
+
+unsigned int OcclusionQuery::GetQueryResult() const
+{
+	GLuint sampleCount;
+
+	if (sUseArbQueries)
+	{
+//		GLint sampleCount;
+		glGetQueryObjectuivARB(mId, GL_QUERY_RESULT_ARB, &sampleCount);
+		return sampleCount;
+	}
+	else
+	{	
+
+		glGetOcclusionQueryuivNV(mId, GL_PIXEL_COUNT_NV, &sampleCount);
+		return sampleCount;
+	}	
+}
+
+
+void OcclusionQuery::GenQueries(std::vector<OcclusionQuery * > &queries, const int numQueries)
+{
+	if ((int)queries.size() < numQueries)
+	{
+		const int n = numQueries - (int)queries.size();
+		unsigned int *newQueries = new unsigned int[n];
+
+
+		if (sUseArbQueries)
+		{
+			glGenQueriesARB(n, (unsigned int *)newQueries);
+		}
+		else
+		{
+			glGenOcclusionQueriesNV(n, (unsigned int *)newQueries);
+		}
+
+		for (int i = 0; i < n; ++ i)
+		{
+			queries.push_back(new OcclusionQuery(newQueries[i]));
+			//cout << "q: " << i << " id: " << newQueries[i] << endl;
+		}
+
+		delete [] newQueries;
+	}
+}
+} // namespace
Index: GTP/trunk/Lib/Vis/Preprocessing/src/UnigraphicsParser.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/UnigraphicsParser.cpp	(revision 863)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/UnigraphicsParser.cpp	(revision 1001)
@@ -12,4 +12,6 @@
 #include "Material.h"
 #include "Environment.h"
+#include "ResourceManager.h"
+
 
 namespace GtpVisibilityPreprocessor {
@@ -60,5 +62,5 @@
 
   SceneGraphNode *root = new SceneGraphNode;
-  Mesh *currentMesh = new Mesh;
+  Mesh *currentMesh = MeshManager::GetSingleton()->CreateResource();
 
   int meshGrouping;
@@ -145,5 +147,5 @@
 	c = cht.find(str);
 	if (currentMesh->mMaterial == NULL) {
-	  Material *mat = new Material;
+		Material *mat = MaterialManager::GetSingleton()->CreateResource();
 	  if (c != cht.end()) {
 	    mat->mDiffuseColor = RgbColor((*c).second.x, (*c).second.y, (*c).second.z);
@@ -151,6 +153,5 @@
 	  }
 	  else
-	    *mat = RandomMaterial();
-	  currentMesh->mMaterial = mat;
+	    currentMesh->AssignRandomMaterial();
 	}
       }
Index: GTP/trunk/Lib/Vis/Preprocessing/src/VspBspTree.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/VspBspTree.cpp	(revision 978)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/VspBspTree.cpp	(revision 1001)
@@ -313,5 +313,20 @@
 			mesh = dynamic_cast<ViewCell *>(object)->GetMesh();
 			break;
-			// TODO: handle transformed mesh instances
+		case Intersectable::TRANSFORMED_MESH_INSTANCE:
+			{
+				TransformedMeshInstance *mi = dynamic_cast<TransformedMeshInstance *>(object);
+
+				if (!mi->GetMesh())
+					break;
+
+				mesh = new Mesh(*mi->GetMesh());
+
+				Matrix4x4 m;
+				mi->GetWorldTransform(m);
+
+				mesh->ApplyTransformation(m);
+
+                break;
+			}
 		default:
 			Debug << "intersectable type not supported" << endl;
@@ -323,4 +338,8 @@
 			mBox.Include(object->GetBox()); // add to BSP tree aabb
 			AddMeshToPolygons(mesh, polys, NULL);
+
+			// cleanup
+			if (object->Type() == Intersectable::TRANSFORMED_MESH_INSTANCE)
+				DEL_PTR(mesh);
 		}
 	}
Index: GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsManager.h
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsManager.h	(revision 991)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsManager.h	(revision 1001)
@@ -170,5 +170,6 @@
 	void AddViewCell(ViewCell *viewCell);
 
-	/** Derive view cells from objects.
+	/** Derive view cells from objects. The view ells are created by taking the object
+		geometry into account.
 	*/
 	void DeriveViewCells(const ObjectContainer &objects, 
@@ -597,6 +598,5 @@
 	/// the scene bounding box
 	AxisAlignedBox3 mViewSpaceBox;
-	/// holds the view cell meshes
-	MeshContainer mMeshContainer;
+	
 	/// if view cells should be exported
 	bool mExportViewCells;
